// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: telemetry/Weather.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Weather {

  /// <summary>Holder for reflection information generated from telemetry/Weather.proto</summary>
  public static partial class WeatherReflection {

    #region Descriptor
    /// <summary>File descriptor for telemetry/Weather.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static WeatherReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "Chd0ZWxlbWV0cnkvV2VhdGhlci5wcm90bxIHd2VhdGhlchofZ29vZ2xlL3By",
            "b3RvYnVmL3RpbWVzdGFtcC5wcm90byL7BgoHV2VhdGhlchIUCgd3ZWF0aGVy",
            "GAEgASgJSACIAQESIAoTd2VhdGhlcl9kZXNjcmlwdGlvbhgCIAEoCUgBiAEB",
            "EhkKDHdlYXRoZXJfaWNvbhgDIAEoCUgCiAEBEhgKC3RlbXBlcmF0dXJlGAQg",
            "ASgJSAOIAQESIwoWdGVtcGVyYXR1cmVfZmVlbHNfbGlrZRgFIAEoCUgEiAEB",
            "EiEKFHRlbXBlcmF0dXJlX3B2X3BhbmVsGAYgASgJSAWIAQESFQoIcHJlc3N1",
            "cmUYByABKAlIBogBARIVCghodW1pZGl0eRgIIAEoCUgHiAEBEhcKCmNsb3Vk",
            "aW5lc3MYCSABKAlICIgBARIXCgp3aW5kX3NwZWVkGAogASgJSAmIAQESGAoL",
            "d2luZF9kZWdyZWUYCyABKAlICogBARI/Cg53aW5kX2RpcmVjdGlvbhgMIAEo",
            "DjIiLndlYXRoZXIuV2VhdGhlci5DYXJkaW5hbERpcmVjdGlvbkgLiAEBEhEK",
            "BHJhaW4YDSABKAlIDIgBARIRCgRzbm93GA4gASgJSA2IAQESFwoKaXJyYWRp",
            "YW5jZRgPIAEoCUgOiAEBEh0KEGRhaWx5X2lycmFkaWFuY2UYECABKAlID4gB",
            "ASKXAQoRQ2FyZGluYWxEaXJlY3Rpb24SBQoBThAAEgcKA05ORRABEgYKAk5F",
            "EAISBwoDRU5FEAMSBQoBRRAEEgcKA0VTRRAFEgYKAlNFEAYSBwoDU1NFEAcS",
            "BQoBUxAIEgcKA1NTVxAJEgYKAlNXEAoSBwoDV1NXEAsSBQoBVxAMEgcKA1dO",
            "VxANEgYKAk5XEA4SBwoDTk5XEA9CCgoIX3dlYXRoZXJCFgoUX3dlYXRoZXJf",
            "ZGVzY3JpcHRpb25CDwoNX3dlYXRoZXJfaWNvbkIOCgxfdGVtcGVyYXR1cmVC",
            "GQoXX3RlbXBlcmF0dXJlX2ZlZWxzX2xpa2VCFwoVX3RlbXBlcmF0dXJlX3B2",
            "X3BhbmVsQgsKCV9wcmVzc3VyZUILCglfaHVtaWRpdHlCDQoLX2Nsb3VkaW5l",
            "c3NCDQoLX3dpbmRfc3BlZWRCDgoMX3dpbmRfZGVncmVlQhEKD193aW5kX2Rp",
            "cmVjdGlvbkIHCgVfcmFpbkIHCgVfc25vd0INCgtfaXJyYWRpYW5jZUITChFf",
            "ZGFpbHlfaXJyYWRpYW5jZUJzChtjb20uY29kaWJseS5tb2RlbC50ZWxlbWV0",
            "cnlCDFdlYXRoZXJQcm90b8oCG0RvbWFpbk1vZGVsXFByb3RvXFRlbGVtZXRy",
            "eeICJ0RvbWFpbk1vZGVsXFByb3RvXFRlbGVtZXRyeVxHUEJNZXRhZGF0YWIG",
            "cHJvdG8z"));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Google.Protobuf.WellKnownTypes.TimestampReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Weather.Weather), global::Weather.Weather.Parser, new[]{ "Weather_", "WeatherDescription", "WeatherIcon", "Temperature", "TemperatureFeelsLike", "TemperaturePvPanel", "Pressure", "Humidity", "Cloudiness", "WindSpeed", "WindDegree", "WindDirection", "Rain", "Snow", "Irradiance", "DailyIrradiance" }, new[]{ "Weather", "WeatherDescription", "WeatherIcon", "Temperature", "TemperatureFeelsLike", "TemperaturePvPanel", "Pressure", "Humidity", "Cloudiness", "WindSpeed", "WindDegree", "WindDirection", "Rain", "Snow", "Irradiance", "DailyIrradiance" }, new[]{ typeof(global::Weather.Weather.Types.CardinalDirection) }, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class Weather : pb::IMessage<Weather>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Weather> _parser = new pb::MessageParser<Weather>(() => new Weather());
    private pb::UnknownFieldSet _unknownFields;
    private int _hasBits0;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<Weather> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Weather.WeatherReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Weather() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Weather(Weather other) : this() {
      _hasBits0 = other._hasBits0;
      weather_ = other.weather_;
      weatherDescription_ = other.weatherDescription_;
      weatherIcon_ = other.weatherIcon_;
      temperature_ = other.temperature_;
      temperatureFeelsLike_ = other.temperatureFeelsLike_;
      temperaturePvPanel_ = other.temperaturePvPanel_;
      pressure_ = other.pressure_;
      humidity_ = other.humidity_;
      cloudiness_ = other.cloudiness_;
      windSpeed_ = other.windSpeed_;
      windDegree_ = other.windDegree_;
      windDirection_ = other.windDirection_;
      rain_ = other.rain_;
      snow_ = other.snow_;
      irradiance_ = other.irradiance_;
      dailyIrradiance_ = other.dailyIrradiance_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Weather Clone() {
      return new Weather(this);
    }

    /// <summary>Field number for the "weather" field.</summary>
    public const int Weather_FieldNumber = 1;
    private string weather_;
    /// <summary>
    /// Group of weather parameters (Rain, Snow, Extreme etc.)
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Weather_ {
      get { return weather_ ?? ""; }
      set {
        weather_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "weather" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasWeather_ {
      get { return weather_ != null; }
    }
    /// <summary>Clears the value of the "weather" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearWeather_() {
      weather_ = null;
    }

    /// <summary>Field number for the "weather_description" field.</summary>
    public const int WeatherDescriptionFieldNumber = 2;
    private string weatherDescription_;
    /// <summary>
    /// Weather condition within the group. You can get the output in your language.
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string WeatherDescription {
      get { return weatherDescription_ ?? ""; }
      set {
        weatherDescription_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "weather_description" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasWeatherDescription {
      get { return weatherDescription_ != null; }
    }
    /// <summary>Clears the value of the "weather_description" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearWeatherDescription() {
      weatherDescription_ = null;
    }

    /// <summary>Field number for the "weather_icon" field.</summary>
    public const int WeatherIconFieldNumber = 3;
    private string weatherIcon_;
    /// <summary>
    /// Weather icon id, for openweathermap codes check (https://openweathermap.org/weather-conditions)
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string WeatherIcon {
      get { return weatherIcon_ ?? ""; }
      set {
        weatherIcon_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "weather_icon" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasWeatherIcon {
      get { return weatherIcon_ != null; }
    }
    /// <summary>Clears the value of the "weather_icon" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearWeatherIcon() {
      weatherIcon_ = null;
    }

    /// <summary>Field number for the "temperature" field.</summary>
    public const int TemperatureFieldNumber = 4;
    private string temperature_;
    /// <summary>
    /// Temperature. Celsius [°C]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Temperature {
      get { return temperature_ ?? ""; }
      set {
        temperature_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "temperature" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTemperature {
      get { return temperature_ != null; }
    }
    /// <summary>Clears the value of the "temperature" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTemperature() {
      temperature_ = null;
    }

    /// <summary>Field number for the "temperature_feels_like" field.</summary>
    public const int TemperatureFeelsLikeFieldNumber = 5;
    private string temperatureFeelsLike_;
    /// <summary>
    /// This temperature parameter accounts for the human perception of weather.  Celsius [°C]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string TemperatureFeelsLike {
      get { return temperatureFeelsLike_ ?? ""; }
      set {
        temperatureFeelsLike_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "temperature_feels_like" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTemperatureFeelsLike {
      get { return temperatureFeelsLike_ != null; }
    }
    /// <summary>Clears the value of the "temperature_feels_like" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTemperatureFeelsLike() {
      temperatureFeelsLike_ = null;
    }

    /// <summary>Field number for the "temperature_pv_panel" field.</summary>
    public const int TemperaturePvPanelFieldNumber = 6;
    private string temperaturePvPanel_;
    /// <summary>
    /// PV Panel Temperature. Celsius [°C]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string TemperaturePvPanel {
      get { return temperaturePvPanel_ ?? ""; }
      set {
        temperaturePvPanel_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "temperature_pv_panel" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTemperaturePvPanel {
      get { return temperaturePvPanel_ != null; }
    }
    /// <summary>Clears the value of the "temperature_pv_panel" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTemperaturePvPanel() {
      temperaturePvPanel_ = null;
    }

    /// <summary>Field number for the "pressure" field.</summary>
    public const int PressureFieldNumber = 7;
    private string pressure_;
    /// <summary>
    /// Atmospheric pressure [hPa]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Pressure {
      get { return pressure_ ?? ""; }
      set {
        pressure_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "pressure" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasPressure {
      get { return pressure_ != null; }
    }
    /// <summary>Clears the value of the "pressure" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearPressure() {
      pressure_ = null;
    }

    /// <summary>Field number for the "humidity" field.</summary>
    public const int HumidityFieldNumber = 8;
    private string humidity_;
    /// <summary>
    /// Humidity [%]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Humidity {
      get { return humidity_ ?? ""; }
      set {
        humidity_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "humidity" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasHumidity {
      get { return humidity_ != null; }
    }
    /// <summary>Clears the value of the "humidity" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearHumidity() {
      humidity_ = null;
    }

    /// <summary>Field number for the "cloudiness" field.</summary>
    public const int CloudinessFieldNumber = 9;
    private string cloudiness_;
    /// <summary>
    /// Cloudiness [%]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Cloudiness {
      get { return cloudiness_ ?? ""; }
      set {
        cloudiness_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "cloudiness" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasCloudiness {
      get { return cloudiness_ != null; }
    }
    /// <summary>Clears the value of the "cloudiness" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearCloudiness() {
      cloudiness_ = null;
    }

    /// <summary>Field number for the "wind_speed" field.</summary>
    public const int WindSpeedFieldNumber = 10;
    private string windSpeed_;
    /// <summary>
    /// Wind speed [m/s]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string WindSpeed {
      get { return windSpeed_ ?? ""; }
      set {
        windSpeed_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "wind_speed" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasWindSpeed {
      get { return windSpeed_ != null; }
    }
    /// <summary>Clears the value of the "wind_speed" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearWindSpeed() {
      windSpeed_ = null;
    }

    /// <summary>Field number for the "wind_degree" field.</summary>
    public const int WindDegreeFieldNumber = 11;
    private string windDegree_;
    /// <summary>
    /// Wind degree [°]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string WindDegree {
      get { return windDegree_ ?? ""; }
      set {
        windDegree_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "wind_degree" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasWindDegree {
      get { return windDegree_ != null; }
    }
    /// <summary>Clears the value of the "wind_degree" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearWindDegree() {
      windDegree_ = null;
    }

    /// <summary>Field number for the "wind_direction" field.</summary>
    public const int WindDirectionFieldNumber = 12;
    private global::Weather.Weather.Types.CardinalDirection windDirection_;
    /// <summary>
    /// Wind direction (world directions)
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Weather.Weather.Types.CardinalDirection WindDirection {
      get { if ((_hasBits0 & 1) != 0) { return windDirection_; } else { return global::Weather.Weather.Types.CardinalDirection.N; } }
      set {
        _hasBits0 |= 1;
        windDirection_ = value;
      }
    }
    /// <summary>Gets whether the "wind_direction" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasWindDirection {
      get { return (_hasBits0 & 1) != 0; }
    }
    /// <summary>Clears the value of the "wind_direction" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearWindDirection() {
      _hasBits0 &= ~1;
    }

    /// <summary>Field number for the "rain" field.</summary>
    public const int RainFieldNumber = 13;
    private string rain_;
    /// <summary>
    /// Rain volume for the last 1 hour, [mm]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Rain {
      get { return rain_ ?? ""; }
      set {
        rain_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "rain" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasRain {
      get { return rain_ != null; }
    }
    /// <summary>Clears the value of the "rain" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearRain() {
      rain_ = null;
    }

    /// <summary>Field number for the "snow" field.</summary>
    public const int SnowFieldNumber = 14;
    private string snow_;
    /// <summary>
    /// Snow volume for the last 1 hour, [mm]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Snow {
      get { return snow_ ?? ""; }
      set {
        snow_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "snow" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasSnow {
      get { return snow_ != null; }
    }
    /// <summary>Clears the value of the "snow" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearSnow() {
      snow_ = null;
    }

    /// <summary>Field number for the "irradiance" field.</summary>
    public const int IrradianceFieldNumber = 15;
    private string irradiance_;
    /// <summary>
    /// Solar irradiance [W/m2]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Irradiance {
      get { return irradiance_ ?? ""; }
      set {
        irradiance_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "irradiance" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasIrradiance {
      get { return irradiance_ != null; }
    }
    /// <summary>Clears the value of the "irradiance" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearIrradiance() {
      irradiance_ = null;
    }

    /// <summary>Field number for the "daily_irradiance" field.</summary>
    public const int DailyIrradianceFieldNumber = 16;
    private string dailyIrradiance_;
    /// <summary>
    /// Daily solar irradiance [Wh/m2]
    /// </summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string DailyIrradiance {
      get { return dailyIrradiance_ ?? ""; }
      set {
        dailyIrradiance_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "daily_irradiance" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasDailyIrradiance {
      get { return dailyIrradiance_ != null; }
    }
    /// <summary>Clears the value of the "daily_irradiance" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearDailyIrradiance() {
      dailyIrradiance_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as Weather);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(Weather other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Weather_ != other.Weather_) return false;
      if (WeatherDescription != other.WeatherDescription) return false;
      if (WeatherIcon != other.WeatherIcon) return false;
      if (Temperature != other.Temperature) return false;
      if (TemperatureFeelsLike != other.TemperatureFeelsLike) return false;
      if (TemperaturePvPanel != other.TemperaturePvPanel) return false;
      if (Pressure != other.Pressure) return false;
      if (Humidity != other.Humidity) return false;
      if (Cloudiness != other.Cloudiness) return false;
      if (WindSpeed != other.WindSpeed) return false;
      if (WindDegree != other.WindDegree) return false;
      if (WindDirection != other.WindDirection) return false;
      if (Rain != other.Rain) return false;
      if (Snow != other.Snow) return false;
      if (Irradiance != other.Irradiance) return false;
      if (DailyIrradiance != other.DailyIrradiance) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (HasWeather_) hash ^= Weather_.GetHashCode();
      if (HasWeatherDescription) hash ^= WeatherDescription.GetHashCode();
      if (HasWeatherIcon) hash ^= WeatherIcon.GetHashCode();
      if (HasTemperature) hash ^= Temperature.GetHashCode();
      if (HasTemperatureFeelsLike) hash ^= TemperatureFeelsLike.GetHashCode();
      if (HasTemperaturePvPanel) hash ^= TemperaturePvPanel.GetHashCode();
      if (HasPressure) hash ^= Pressure.GetHashCode();
      if (HasHumidity) hash ^= Humidity.GetHashCode();
      if (HasCloudiness) hash ^= Cloudiness.GetHashCode();
      if (HasWindSpeed) hash ^= WindSpeed.GetHashCode();
      if (HasWindDegree) hash ^= WindDegree.GetHashCode();
      if (HasWindDirection) hash ^= WindDirection.GetHashCode();
      if (HasRain) hash ^= Rain.GetHashCode();
      if (HasSnow) hash ^= Snow.GetHashCode();
      if (HasIrradiance) hash ^= Irradiance.GetHashCode();
      if (HasDailyIrradiance) hash ^= DailyIrradiance.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (HasWeather_) {
        output.WriteRawTag(10);
        output.WriteString(Weather_);
      }
      if (HasWeatherDescription) {
        output.WriteRawTag(18);
        output.WriteString(WeatherDescription);
      }
      if (HasWeatherIcon) {
        output.WriteRawTag(26);
        output.WriteString(WeatherIcon);
      }
      if (HasTemperature) {
        output.WriteRawTag(34);
        output.WriteString(Temperature);
      }
      if (HasTemperatureFeelsLike) {
        output.WriteRawTag(42);
        output.WriteString(TemperatureFeelsLike);
      }
      if (HasTemperaturePvPanel) {
        output.WriteRawTag(50);
        output.WriteString(TemperaturePvPanel);
      }
      if (HasPressure) {
        output.WriteRawTag(58);
        output.WriteString(Pressure);
      }
      if (HasHumidity) {
        output.WriteRawTag(66);
        output.WriteString(Humidity);
      }
      if (HasCloudiness) {
        output.WriteRawTag(74);
        output.WriteString(Cloudiness);
      }
      if (HasWindSpeed) {
        output.WriteRawTag(82);
        output.WriteString(WindSpeed);
      }
      if (HasWindDegree) {
        output.WriteRawTag(90);
        output.WriteString(WindDegree);
      }
      if (HasWindDirection) {
        output.WriteRawTag(96);
        output.WriteEnum((int) WindDirection);
      }
      if (HasRain) {
        output.WriteRawTag(106);
        output.WriteString(Rain);
      }
      if (HasSnow) {
        output.WriteRawTag(114);
        output.WriteString(Snow);
      }
      if (HasIrradiance) {
        output.WriteRawTag(122);
        output.WriteString(Irradiance);
      }
      if (HasDailyIrradiance) {
        output.WriteRawTag(130, 1);
        output.WriteString(DailyIrradiance);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (HasWeather_) {
        output.WriteRawTag(10);
        output.WriteString(Weather_);
      }
      if (HasWeatherDescription) {
        output.WriteRawTag(18);
        output.WriteString(WeatherDescription);
      }
      if (HasWeatherIcon) {
        output.WriteRawTag(26);
        output.WriteString(WeatherIcon);
      }
      if (HasTemperature) {
        output.WriteRawTag(34);
        output.WriteString(Temperature);
      }
      if (HasTemperatureFeelsLike) {
        output.WriteRawTag(42);
        output.WriteString(TemperatureFeelsLike);
      }
      if (HasTemperaturePvPanel) {
        output.WriteRawTag(50);
        output.WriteString(TemperaturePvPanel);
      }
      if (HasPressure) {
        output.WriteRawTag(58);
        output.WriteString(Pressure);
      }
      if (HasHumidity) {
        output.WriteRawTag(66);
        output.WriteString(Humidity);
      }
      if (HasCloudiness) {
        output.WriteRawTag(74);
        output.WriteString(Cloudiness);
      }
      if (HasWindSpeed) {
        output.WriteRawTag(82);
        output.WriteString(WindSpeed);
      }
      if (HasWindDegree) {
        output.WriteRawTag(90);
        output.WriteString(WindDegree);
      }
      if (HasWindDirection) {
        output.WriteRawTag(96);
        output.WriteEnum((int) WindDirection);
      }
      if (HasRain) {
        output.WriteRawTag(106);
        output.WriteString(Rain);
      }
      if (HasSnow) {
        output.WriteRawTag(114);
        output.WriteString(Snow);
      }
      if (HasIrradiance) {
        output.WriteRawTag(122);
        output.WriteString(Irradiance);
      }
      if (HasDailyIrradiance) {
        output.WriteRawTag(130, 1);
        output.WriteString(DailyIrradiance);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (HasWeather_) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Weather_);
      }
      if (HasWeatherDescription) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(WeatherDescription);
      }
      if (HasWeatherIcon) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(WeatherIcon);
      }
      if (HasTemperature) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Temperature);
      }
      if (HasTemperatureFeelsLike) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(TemperatureFeelsLike);
      }
      if (HasTemperaturePvPanel) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(TemperaturePvPanel);
      }
      if (HasPressure) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Pressure);
      }
      if (HasHumidity) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Humidity);
      }
      if (HasCloudiness) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Cloudiness);
      }
      if (HasWindSpeed) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(WindSpeed);
      }
      if (HasWindDegree) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(WindDegree);
      }
      if (HasWindDirection) {
        size += 1 + pb::CodedOutputStream.ComputeEnumSize((int) WindDirection);
      }
      if (HasRain) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Rain);
      }
      if (HasSnow) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Snow);
      }
      if (HasIrradiance) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Irradiance);
      }
      if (HasDailyIrradiance) {
        size += 2 + pb::CodedOutputStream.ComputeStringSize(DailyIrradiance);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(Weather other) {
      if (other == null) {
        return;
      }
      if (other.HasWeather_) {
        Weather_ = other.Weather_;
      }
      if (other.HasWeatherDescription) {
        WeatherDescription = other.WeatherDescription;
      }
      if (other.HasWeatherIcon) {
        WeatherIcon = other.WeatherIcon;
      }
      if (other.HasTemperature) {
        Temperature = other.Temperature;
      }
      if (other.HasTemperatureFeelsLike) {
        TemperatureFeelsLike = other.TemperatureFeelsLike;
      }
      if (other.HasTemperaturePvPanel) {
        TemperaturePvPanel = other.TemperaturePvPanel;
      }
      if (other.HasPressure) {
        Pressure = other.Pressure;
      }
      if (other.HasHumidity) {
        Humidity = other.Humidity;
      }
      if (other.HasCloudiness) {
        Cloudiness = other.Cloudiness;
      }
      if (other.HasWindSpeed) {
        WindSpeed = other.WindSpeed;
      }
      if (other.HasWindDegree) {
        WindDegree = other.WindDegree;
      }
      if (other.HasWindDirection) {
        WindDirection = other.WindDirection;
      }
      if (other.HasRain) {
        Rain = other.Rain;
      }
      if (other.HasSnow) {
        Snow = other.Snow;
      }
      if (other.HasIrradiance) {
        Irradiance = other.Irradiance;
      }
      if (other.HasDailyIrradiance) {
        DailyIrradiance = other.DailyIrradiance;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            Weather_ = input.ReadString();
            break;
          }
          case 18: {
            WeatherDescription = input.ReadString();
            break;
          }
          case 26: {
            WeatherIcon = input.ReadString();
            break;
          }
          case 34: {
            Temperature = input.ReadString();
            break;
          }
          case 42: {
            TemperatureFeelsLike = input.ReadString();
            break;
          }
          case 50: {
            TemperaturePvPanel = input.ReadString();
            break;
          }
          case 58: {
            Pressure = input.ReadString();
            break;
          }
          case 66: {
            Humidity = input.ReadString();
            break;
          }
          case 74: {
            Cloudiness = input.ReadString();
            break;
          }
          case 82: {
            WindSpeed = input.ReadString();
            break;
          }
          case 90: {
            WindDegree = input.ReadString();
            break;
          }
          case 96: {
            WindDirection = (global::Weather.Weather.Types.CardinalDirection) input.ReadEnum();
            break;
          }
          case 106: {
            Rain = input.ReadString();
            break;
          }
          case 114: {
            Snow = input.ReadString();
            break;
          }
          case 122: {
            Irradiance = input.ReadString();
            break;
          }
          case 130: {
            DailyIrradiance = input.ReadString();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            Weather_ = input.ReadString();
            break;
          }
          case 18: {
            WeatherDescription = input.ReadString();
            break;
          }
          case 26: {
            WeatherIcon = input.ReadString();
            break;
          }
          case 34: {
            Temperature = input.ReadString();
            break;
          }
          case 42: {
            TemperatureFeelsLike = input.ReadString();
            break;
          }
          case 50: {
            TemperaturePvPanel = input.ReadString();
            break;
          }
          case 58: {
            Pressure = input.ReadString();
            break;
          }
          case 66: {
            Humidity = input.ReadString();
            break;
          }
          case 74: {
            Cloudiness = input.ReadString();
            break;
          }
          case 82: {
            WindSpeed = input.ReadString();
            break;
          }
          case 90: {
            WindDegree = input.ReadString();
            break;
          }
          case 96: {
            WindDirection = (global::Weather.Weather.Types.CardinalDirection) input.ReadEnum();
            break;
          }
          case 106: {
            Rain = input.ReadString();
            break;
          }
          case 114: {
            Snow = input.ReadString();
            break;
          }
          case 122: {
            Irradiance = input.ReadString();
            break;
          }
          case 130: {
            DailyIrradiance = input.ReadString();
            break;
          }
        }
      }
    }
    #endif

    #region Nested types
    /// <summary>Container for nested types declared in the Weather message type.</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static partial class Types {
      public enum CardinalDirection {
        [pbr::OriginalName("N")] N = 0,
        [pbr::OriginalName("NNE")] Nne = 1,
        [pbr::OriginalName("NE")] Ne = 2,
        [pbr::OriginalName("ENE")] Ene = 3,
        [pbr::OriginalName("E")] E = 4,
        [pbr::OriginalName("ESE")] Ese = 5,
        [pbr::OriginalName("SE")] Se = 6,
        [pbr::OriginalName("SSE")] Sse = 7,
        [pbr::OriginalName("S")] S = 8,
        [pbr::OriginalName("SSW")] Ssw = 9,
        [pbr::OriginalName("SW")] Sw = 10,
        [pbr::OriginalName("WSW")] Wsw = 11,
        [pbr::OriginalName("W")] W = 12,
        [pbr::OriginalName("WNW")] Wnw = 13,
        [pbr::OriginalName("NW")] Nw = 14,
        [pbr::OriginalName("NNW")] Nnw = 15,
      }

    }
    #endregion

  }

  #endregion

}

#endregion Designer generated code
